<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: formatter.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: formatter.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * The formatter module provides a collection of utility methods for date &amp; number formatting.
 *
 * The formats are specified by the pattern string. The pattern strings are designed to
 * conform to java.text.SimpleDateFormat and java.text.DecimalFormat.
 *
 * ##### Usage
 *     // Mar 04 2010 05:06:07.008 at local time
 *     var localTime = new Date(2010, 2, 4, 5, 6, 7, 8);
 *
 *     // format by the pattern.
 *     var options = {};
 *
 *     options.pattern = "yyyy/MM/dd HH:mm:ss.SSS";
 *     expect(formatter.format(localTime, options)).to.equal("2010/03/04 05:06:07.008");
 *
 *     options.pattern = "yyyy/MM/dd";
 *     expect(formatter.format(localTime, options)).to.equal("2010/03/04");
 *
 *     options.pattern = "NT$#,##0.##";
 *     expect(formatter.format(123456.789, options)).to.equal("NT$123,456.79");
 *
 *     options.pattern = "#,##0.##";
 *     expect(formatter.format(123456, options)).to.equal("123,456");
 *
 *     // format by the subtype and locale.
 *     var options = {};
 *     var locale = {language: "en", country: "US"};
 *     options.locale = locale;
 *
 *     options.subtype = undefined;
 *     expect(i18n.datetimePattern(locale)).to.equal("MM/dd/yyyy HH:mm:ss");
 *     expect(formatter.format(localTime, options)).to.equal("03/04/2010 05:06:07");
 *
 *     options.subtype = "date";
 *     expect(i18n.datePattern(locale)).to.equal("MM/dd/yyyy");
 *     expect(formatter.format(localTime, options)).to.equal("03/04/2010");
 *
 *     options.subtype = "time";
 *     expect(i18n.timePattern(locale)).to.equal("HH:mm:ss");
 *     expect(formatter.format(localTime, options)).to.equal("05:06:07");
 *
 *     options.subtype = "currency";
 *     expect(i18n.currencyPattern(locale)).to.equal("USD#,##0.##");
 *     expect(formatter.format(123456.789, options)).to.equal("USD123,456.79");
 *
 *     options.subtype = undefined;
 *     expect(i18n.numberPattern(locale)).to.equal("#,##0.##");
 *     expect(formatter.format(123456, options)).to.equal("123,456")
 *
 * @module formatter
 * @author  Jason Lin
 * @since   1.0
 */
define(['underscore', 'uweaver/lang', 'uweaver/i18n', 'uweaver/datetime',
    'uweaver/number'], function(_, lang, i18n, datetime, number) {
    /**
     * The method formats a value to a string representation using the specified subtype, locale and pattern.
     *
     * @memberof module:formatter
     * @param {Date|Number|Boolean|String} value - the value to format.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.subtype] - specify the subtype of the value to select to pattern to format the value.
     * @param {Locale} [options.locale] - specify the locale to select the pattern to format the value.
     * @param {String} [options.pattern] - specify a pattern to format the value.
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {String}
     */
    function format(value, options) {
        if(value===undefined||value===null) return "";

        if(typeof(value)==="string") return value;

        options || (options = {});

        var type = lang.type(value);

        var text;

        if(type==="date") {
            text = formatDate(value, options);
        } else if(type==="number") {
            text = formatNumber(value, options);
        }

        return text;
    }

    /**
     * The method parse a string to a value using the specified type, subtype, locale and pattern.
     *
     * @memberof module:formatter
     * @param {String} text - the string to parse.
     * @param {String} type - the type of return value.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.subtype] - specify the subtype of the value to select to pattern to format the value.
     * @param {Locale} [options.locale] - specify the locale to select the pattern to format the value.
     * @param {String} [options.pattern] - specify a pattern to format the value.
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {Date|Number|Boolean|String}
     */
    function parse(text, type, options) {
        if(text===undefined||text===""||text===null) return null;

        options || (options = {});

        var value;
        if(type==="date") {
            value = parseDate(text, options);
        } else if(type==="number") {
            value = parseNumber(text, options);
        } else if(type==='string') {
            value = text;
        }

        return value;
    }

    /**
     * The method tests if a string representation is valid using the specified type, subtype, locale and pattern.
     *
     * @memberof module:formatter
     * @param {String} text - the string to test.
     * @param {String} type - the type of the string representation.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.subtype] - specify the subtype of the value to select to pattern to format the value.
     * @param {Locale} [options.locale] - specify the locale to select the pattern to format the value.
     * @param {String} [options.pattern] - specify a pattern to format the value.
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {Boolean}
     */
    function test(text, type, options) {
        if(text===undefined||text===""||text===null) return true;

        options || (options = {});

        var compliant;
        if(type==="date") {
            compliant = testDate(text, options);
        } else if(type==="number") {
            compliant = testNumber(text, options);
        } else if(type==='string') {
            compliant = text;
        }

        return compliant;
    }

    function testDate(text, options) {
        options || (options = {});

        var pattern;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="date") {
            pattern = i18n.datePattern(locale);
        } else if(subtype==="time") {
            pattern = i18n.timePattern(locale);
        } else if(subtype==="month") {
            pattern = i18n.monthPattern(locale);
        } else {
            pattern = i18n.datetimePattern(locale);
        }

        return datetime.test(text, pattern);
    }

    function testNumber(text, options) {
        options || (options = {});

        var pattern, decimalSeparator, groupingSeparator;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="currency") {
            pattern = i18n.currencyPattern(locale);
        } else {
            pattern = i18n.numberPattern(locale);
        }

        decimalSeparator = options.decimalSeparator ? options.decimalSeparator : i18n.decimalSeparator(locale);
        groupingSeparator = options.groupingSeparator ? options.groupingSeparator : i18n.groupingSeparator(locale);

        return number.test(text, pattern, {
            decimalSeparator: decimalSeparator,
            groupingSeparator: groupingSeparator
        });
    }


    function parseDate(text, options) {
        options || (options = {});

        var pattern;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="date") {
            pattern = i18n.datePattern(locale);
        } else if(subtype==="time") {
            pattern = i18n.timePattern(locale);
        } else if(subtype==="month") {
            pattern = i18n.monthPattern(locale);
        } else {
            pattern = i18n.datetimePattern(locale);
        }

        return datetime.parse(text, pattern);
    }

    function parseNumber(text, options) {
        options || (options = {});

        var pattern, decimalSeparator, groupingSeparator;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="currency") {
            pattern = i18n.currencyPattern(locale);
        } else {
            pattern = i18n.numberPattern(locale);
        }

        decimalSeparator = options.decimalSeparator ? options.decimalSeparator : i18n.decimalSeparator(locale);
        groupingSeparator = options.groupingSeparator ? options.groupingSeparator : i18n.groupingSeparator(locale);

        return number.parse(text, pattern, {
            decimalSeparator: decimalSeparator,
            groupingSeparator: groupingSeparator
        });
    }

    function formatDate(value, options) {
        options || (options = {});

        var pattern;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="date") {
            pattern = i18n.datePattern(locale);
        } else if(subtype==="time") {
            pattern = i18n.timePattern(locale);
        } else if(subtype==='month') {
            pattern = i18n.monthPattern(locale);
        } else {  pattern = i18n.datetimePattern(locale);
        }

        return datetime.format(value, pattern);

    }

    function formatNumber(value, options) {
        options || (options = {});

        var pattern, decimalSeparator, groupingSeparator;
        var subtype = options.subtype;
        var locale = options.locale;

        if(options.pattern) {
            pattern = options.pattern;
        } else if(subtype==="currency") {
            pattern = i18n.currencyPattern(locale);
        } else {
            pattern = i18n.numberPattern(locale);
        }

        decimalSeparator = options.decimalSeparator ? options.decimalSeparator : i18n.decimalSeparator(locale);
        groupingSeparator = options.groupingSeparator ? options.groupingSeparator : i18n.groupingSeparator(locale);

        return number.format(value, pattern, {
            decimalSeparator: decimalSeparator,
            groupingSeparator: groupingSeparator
        });
    }

    return {
        format: format,
        parse: parse,
        test: test
    };
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
